import java.util.Collection;
import java.util.Comparator;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;
import java.util.TreeSet;


public class Anagrama{
	private Map<Palabra, Set<Palabra>> anagrama;
	
	public Anagrama(){
		anagrama = new TreeMap<Palabra, Set<Palabra>>();
	}
	public Anagrama(Comparator <Palabra>cs){
		//TreeMap(Comparator<? super K> o)
		anagrama = new TreeMap<Palabra, Set<Palabra>>(cs);
	}
	public void nuevaPalabra(String pal){
		Palabra sPal = new Palabra(pal);
		if(!anagrama.containsKey(sPal)){
			Set<Palabra> conjunto = new TreeSet<Palabra>();
			anagrama.put(sPal, conjunto);
			for(Palabra p: anagrama.keySet()){
				if(sPal.esAnagrama(p)&& !sPal.equals(p)){
					anagrama.get(p).add(sPal);
					anagrama.get(sPal).add(p);
				}
			}
		}
	}
	public void mostrarEnConsola(){
		String line ="";
		
		Set st = anagrama.keySet();
		Iterator iKeys = st.iterator();
		
		Collection c = anagrama.values();
		Iterator iVal = c.iterator();
		
		while(iKeys.hasNext()){
			line += iKeys.next()+" ";
			line +=(iVal.next());
			line += "\n";
		}
		System.out.println(line);
	}
}
